/**
 * A discrete event agent
 * A DSAgent doesn't act().
 * A DSAgent adds events to the queue, and requests resources.
 * @author Mark Guzdial
 * @author Barb Ericson
 */
public class DSAgent extends Agent {
  
  //////////////// Fields /////////////////////
    
  /** flag if blocked (waiting) */
  private boolean blocked;
  
    ////////////////////////////// Constructors ////////////////////////
  // Copy this section AS-IS into subclasses, but rename Agent to 
  // Your class.
  
  /**
   * Constructor that takes the model display (the original
   * position will be randomly assigned) and the simulation
   * @param modelDisplayer thing that displays the model
   * @param thisSim my simulation
   */
  public DSAgent (ModelDisplay modelDisplayer,Simulation thisSim)
  {
    super(randNumGen.nextInt(modelDisplayer.getWidth()),
          randNumGen.nextInt(modelDisplayer.getHeight()),
          modelDisplayer, thisSim);
  }
  
  /** Constructor that takes the x and y, a model
   * display to draw it on, and the simulation
   * @param x the starting x position
   * @param y the starting y position
   * @param modelDisplayer the thing that displays the model
   * @param thisSim my simulation
   */
  public DSAgent (int x, int y, ModelDisplay modelDisplayer, 
                  Simulation thisSim) { 
    // let the parent constructor handle it
    super(x,y,modelDisplayer,thisSim);
  }
  
  /** 
   * Method to initialize the simulation
   * @param thisSim the simulation
   */
  public void init(Simulation thisSim) {
    
    // use the parent init method first
    super.init(thisSim);
    
    // Start out unblocked
    blocked = false;
  }  
  
}
