/**
 * Class that represents a stack of pictures
 * @author Mark Guzdial
 * @author Barb Ericson
 */
public class PictureStack {
  
  /** store the elements in a linked list */
  private SceneElement elements = null;
  
  /**
   * Constructor 
   */
  public PictureStack() {
    // If our SceneElement had an empty first
    // node, we'd create it here.
  }
  
  //// Methods ///
  
  /**
   * Method to add an element to the stack 
   * @param element the element to add
   */
  public void push(SceneElement element) {
    if (elements == null) {
      // First new element on the stack
      // becomes the one that we point at
      elements = element;
    }
    else {
      // New elements go at the front
      //The rest get added to the front
      //by making the new one point to the
      //rest of the list, then change
      //the pointer to the new front.
      element.setNext(elements);
      elements = element;
    }
    
  }
  
  /**
   * Method to return the top element, but 
   * not remove it from the stack
   * @return the top element
   */
  public SceneElement peek() {
    return elements;
  }
  
  /**
   * Method to return the top element
   * from the stack and remove it from
   * the stack
   * @return the top element
   */
  public SceneElement pop() {
    SceneElement toReturn = this.peek();
    elements=elements.getNext();
    return toReturn;
  }
  
  /**
   * Method to return the number of elements in the stack
   * @return the number of elements in the stack
   */
  public int size(){return elements.count();}
  
  /** 
   * Method to return true if the stack is empty
   * @return true if the stack is empty else false
   */
  public boolean isEmpty() {return this.size() == 0;}
  
}
  