import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;

/**
 * Class that represents a swappable composed image
 * @author Mark Guzdial
 * @author Barb Ericson
 */
public class SwappableComposedImage {
  
  /** picture to compose into */
  private Picture composeMe;
  
  /** the window to display in */
  private JFrame myWindow;
  
  /** the label to use for display */
  private JLabel myLabel;
  
  /** the x location */
  private int locx = 0;
  
  /** the y location */
  private int locy = 0;
  
  /**
   * Method to make the image
   */
  public void makeMe() {
    myWindow = new JFrame();
    myWindow.getContentPane().setLayout(null);
    myLabel = new JLabel();
    myWindow.getContentPane().add(myLabel);
    myWindow.setVisible(true);
  }
  
//  public void showMe() {
//    Container mypane = myframe.getContentPane();
//    mypane.setLayout(null);
//    ImageIcon myIcon = new ImageIcon(composeMe.getImage());
//    JLabel mylabel = new JLabel(myIcon);
//    mylabel.setBounds(locx,locy,
//                      myIcon.getIconWidth(),myIcon.getIconHeight());
//    mypane.add(mylabel);
////    mylabel.setLocation(locx,locy);
//                                 
////    Graphics g = myframe.getContentPane().getGraphics();
////    g.drawImage(composeMe.getImage(),locx,locy,myframe);
//  };
  
  /**
   * Method to set the x and y location
   * @param x the x location to use
   * @param y the y location to use
   */
  public void setLoc(int x, int y) {
    locx = x;
    locy = y;
    Icon myIcon = myLabel.getIcon(); // Replicated below -- developmental
    myLabel.setBounds(locx,locy,
                      myIcon.getIconWidth(),myIcon.getIconHeight());
    
  }
  
  /**
   * Method to update the bounds of this image
   */
  private void updatePosition() { //replicated above -- developmental
    Icon myIcon = myLabel.getIcon();
    myLabel.setBounds(locx,locy,
                      myIcon.getIconWidth(),myIcon.getIconHeight());
  }
  
  /**
   * Method to let the use pick a picture to use and set it
   */
  public void getImage() {
    composeMe = new Picture(FileChooser.pickAFile());
    ImageIcon myIcon = new ImageIcon(composeMe.getImage());
    myLabel.setIcon(myIcon);
    updatePosition();
  }
  
}
